local CCBabble  = AceLibrary("Babble-Spell-2.2")
local CCLocale  = AceLibrary("AceLocale-2.2"):new("CCBreaker")



CCBreaker:RegisterDefaults("char",{
	debug = false;
	showon = {
		player = false,
		party = false,
		raid = false,
		pet = false,
		partypet = false,
		raidpet = false,
		others = true,
	},
	showfrom = {
		player = true,
		party = true,
		raid = true,
		pet = true,
		partypet = true,
		raidpet = true,
		others = false,
	},
	showeffects = {
		freezingtrap = true,
		hibernate = true,
		polymorph = true,
		shackleundead = true,
		sap = true,
	},
	display = {
		fubar = {
			spell = true,
			target = false,
			breaker = true,
			ability = false,
		},
		center = {
			colors = true,   
			enable = false,
			color = {
				r = 1,
				g = 1,
				b = 0.5,
				a = 0,
				colortext = "|cffff8000"
			},
			strings={
				two=CCLocale["[spell] on [target] was removed"],
				three=CCLocale["[spell] on [target] was removed by [breaker]"],
				four=CCLocale["[spell] on [target] was removed by [breaker]'s [ability]"],
			}
		},
		console = {
			colors = true,   
			enable = true,
			color = {
				r = 1,
				g = 1,
				b = 0.5,
				a = 0,
				colortext = "|cffff8000"
			},
			strings={
				two=CCLocale["[spell] on [target] was removed"],
				three=CCLocale["[spell] on [target] was removed by [breaker]"],
				four=CCLocale["[spell] on [target] was removed by [breaker]'s [ability]"],
			},
		},
	},
})

-- Menu

CCBreaker.OnMenuRequest = {
	type = "group",
	args = {
		debug ={
			type = "toggle",
			name = CCLocale["debug"],
			desc = CCLocale["Enable debug messages"],
			get = function() return CCBreaker.db.char.debug end,
			set = function(v) CCBreaker.db.char.debug = v end, 
		},
		reset = {
			type = "execute",
			name = CCLocale["reset"],
			desc = CCLocale["Reset breaker data"],
			func = "reset",
		},
		display = {
			type = "group",
			name = CCLocale["display"],
			desc = CCLocale["Display options"],
			args = {
				console ={
					type = "group",
					name = CCLocale["console"],
					desc = CCLocale["Display options in console"],
					args = {
						color = {
							type = "toggle",
							name = CCLocale["color text"],
							desc = CCLocale["Color messages"],
							get = function() return CCBreaker.db.char.display.console.colors end,
							set = function(v) CCBreaker.db.char.display.console.colors = v end,
						},
						colors = {
							type = "color",
							name = CCLocale["color"],
							desc = CCLocale["Chose color to use"],
							get = function() local color = CCBreaker.db.char.display.console.color
									  return color.r,color.g,color.b,color.a 
								  end,
							set = function(r,g,b,a) local color = CCBreaker.db.char.display.console.color
									   color.r = r 
									   color.g = g
									   color.b = b
									   color.colortext = string.format("|cff%02x%02x%02x", r * 255, g * 255, b * 255)
								  end,
						},
						enable = {
							type = "toggle",
							name = CCLocale["enable"],
							desc = CCLocale["Display console messages"],
							get = function() return CCBreaker.db.char.display.console.enable end,
							set = function(v) CCBreaker.db.char.display.console.enable = v end,
						},
						text = {
							type = "group",
							name = CCLocale["text"],
							desc = CCLocale["Change the displayed text, leave blank for default"],
							args ={
								two = {
									type = "text",
									name = CCLocale["two"],
									desc = CCLocale["text if only spell an target are given"],
									usage = "[spell], [target]",
									get = function() return CCBreaker.db.char.display.console.strings.two end,
									set = function(v) CCBreaker.db.char.display.console.strings.two = v end,
								},
								three = {
									type = "text",
									name = CCLocale["three"],
									desc = CCLocale["text if only spell, target and breaker are given"],
									usage = "[spell], [target], [breaker]",
									get = function() return CCBreaker.db.char.display.console.strings.three end,
									set = function(v) CCBreaker.db.char.display.console.strings.three = v end,
								},
								four = {
									type = "text",
									name = CCLocale["four"],
									desc = CCLocale["text if spell, target, breaker and ability are given"],
									usage = "[spell], [target], [breaker], [ability]",
									get = function() return CCBreaker.db.char.display.console.strings.four end,
									set = function(v) CCBreaker.db.char.display.console.strings.four = v end,
								},
							},
						},
					},
				},
				center ={
					type = "group",
					name = CCLocale["center"],
					desc = CCLocale["Display options for centered messages"],
					args = {
						color = {
							type = "toggle",
							name = CCLocale["color text"],
							desc = CCLocale["Color messages"],
							get = function() return CCBreaker.db.char.display.center.colors end,
							set = function(v) CCBreaker.db.char.display.center.colors = v end,
						},
						colors = {
							type = "color",
							name = CCLocale["color"],
							desc = CCLocale["Chose color to use"],
							get = function() local color = CCBreaker.db.char.display.center.color
									  return color.r,color.g,color.b,color.a 
								  end,
							set = function(r,g,b,a) local color = CCBreaker.db.char.display.center.color
									   color.r = r 
									   color.g = g
									   color.b = b
									   color.colortext = string.format("|cff%02x%02x%02x", r * 255, g * 255, b * 255)
								  end,
						},
						enable = {
							type = "toggle",
							name = CCLocale["enable"],
							desc = CCLocale["Display centered messages"],
							get = function() return CCBreaker.db.char.display.center.enable end,
							set = function(v) CCBreaker.db.char.display.center.enable = v end,
						},
						text = {
							type = "group",
							name = CCLocale["text"],
							desc = CCLocale["Change the displayed text, leave blank for default"],
							args ={
								two = {
									type = "text",
									name = CCLocale["two"],
									desc = CCLocale["text if only spell an target are given"],
									usage = "[spell], [target]",
									get = function() return CCBreaker.db.char.display.center.strings.two end,
									set = function(v) CCBreaker.db.char.display.center.strings.two = v end,
								},
								three = {
									type = "text",
									name = CCLocale["three"],
									desc = CCLocale["text if only spell, target and breaker are given"],
									usage = "[spell], [target], [breaker]",
									get = function() return CCBreaker.db.char.display.center.strings.three end,
									set = function(v) CCBreaker.db.char.display.center.strings.three = v end,
								},
								four = {
									type = "text",
									name = CCLocale["four"],
									desc = CCLocale["text if spell, target, breaker and ability are given"],
									usage = "[spell], [target], [breaker], [ability]",
									get = function() return CCBreaker.db.char.display.center.strings.four end,
									set = function(v) CCBreaker.db.char.display.center.strings.four = v end,
								},
							},
						},
					},
				},
				fubar = {
					type = "group",
					name = CCLocale["fubar"],
					desc = CCLocale["Display options in Fubar"],
					args = {
						spell = {
							type = "toggle",
							name = CCLocale["spell"],
							desc = CCLocale["Display broken spell"],
							get = function() return CCBreaker.db.char.display.fubar.spell end,
							set = function(v) CCBreaker.db.char.display.fubar.spell = v end,
						},
						target = {
							type = "toggle",
							name = CCLocale["target"],
							desc = CCLocale["Display freed target"],
							get = function() return CCBreaker.db.char.display.fubar.target end,
							set = function(v) CCBreaker.db.char.display.fubar.target = v end,
						},
						breaker = {
							type = "toggle",
							name = CCLocale["breaker"],
							desc = CCLocale["Display who broke CC"],
							get = function() return CCBreaker.db.char.display.fubar.breaker end,
							set = function(v) CCBreaker.db.char.display.fubar.breaker = v end,
						},
						ability = {
							type = "toggle",
							name = CCLocale["ability"],
							desc = CCLocale["Display ability breaking the CC"],
							get = function() return CCBreaker.db.char.display.fubar.ability end,
							set = function(v) CCBreaker.db.char.display.fubar.ability = v end,
						},
					},
				},
			},
		},
		filter = {
			type = "group",
			name = CCLocale["filter"],
			desc = CCLocale["Filter Options"],
			args = {
				showon = {
					type = "group",
					name = CCLocale["show on"],
					desc = CCLocale["report CC breaks to those targets only"],
					args = {
						player = {
							type = "toggle",
							name = CCLocale["player"],
							desc = CCLocale["Show break on player"],
							get = function() return CCBreaker.db.char.showon.player end,
							set = function(v) CCBreaker.db.char.showon.player = v end,
						},
						party = {
							type = "toggle",
							name = CCLocale["party"],
							desc = CCLocale["Show break on party members"],
							get = function() return CCBreaker.db.char.showon.party end,
							set = function(v) CCBreaker.db.char.showon.party = v end,
						},
						raid = {
							type = "toggle",
							name = CCLocale["raid"],
							desc = CCLocale["Show break on raid members"],
							get = function() return CCBreaker.db.char.showon.raid end,
							set = function(v) CCBreaker.db.char.showon.raid = v end,
						},
						pet = {
							type = "toggle",
							name = CCLocale["pet"],
							desc = CCLocale["Show break on your pet"],
							get = function() return CCBreaker.db.char.showon.pet end,
							set = function(v) CCBreaker.db.char.showon.pet = v end,
						},
						partypet = {
							type = "toggle",
							name = CCLocale["party pet"],
							desc = CCLocale["Show break on party pets"],
							get = function() return CCBreaker.db.char.showon.partypet end,
							set = function(v) CCBreaker.db.char.showon.partypet = v end,
						},
						raidpet = {
							type = "toggle",
							name = CCLocale["raid pet"],
							desc = CCLocale["Show break on raid pets"],
							get = function() return CCBreaker.db.char.showon.raidpet end,
							set = function(v) CCBreaker.db.char.showon.raidpet = v end,
						},
						others = {
							type = "toggle",
							name = CCLocale["others"],
							desc = CCLocale["Show break on others"],
							get = function() return CCBreaker.db.char.showon.others end,
							set = function(v) CCBreaker.db.char.showon.others = v end,
						},
					},
			}, 
				showfrom = {
					type = "group",
					name = CCLocale["show from"],
					desc = CCLocale["Report CC breaks from those only"],
					args = {
						player = {
							type = "toggle",
							name = CCLocale["player"],
							desc = CCLocale["Show break from player"],
							get = function() return CCBreaker.db.char.showfrom.player end,
							set = function(v) CCBreaker.db.char.showfrom.player = v end,
						},
						party = {
							type = "toggle",
							name = CCLocale["party"],
							desc = CCLocale["Show break from party members"],
							get = function() return CCBreaker.db.char.showfrom.party end,
							set = function(v) CCBreaker.db.char.showfrom.party = v end,
						},
						raid = {
							type = "toggle",
							name = CCLocale["raid"],
							desc = CCLocale["Show break from raid members"],
							get = function() return CCBreaker.db.char.showfrom.raid end,
							set = function(v) CCBreaker.db.char.showfrom.raid = v end,
						},
						pet = {
							type = "toggle",
							name = CCLocale["pet"],
							desc = CCLocale["Show break from your pet"],
							get = function() return CCBreaker.db.char.showfrom.pet end,
							set = function(v) CCBreaker.db.char.showfrom.pet = v end,
						},
						partypet = {
							type = "toggle",
							name = CCLocale["party pet"],
							desc = CCLocale["Show break from party pets"],
							get = function() return CCBreaker.db.char.showfrom.partypet end,
							set = function(v) CCBreaker.db.char.showfrom.partypet = v end,
						},
						raidpet = {
							type = "toggle",
							name = CCLocale["raid pet"],
							desc = CCLocale["Show break on raid pets"],
							get = function() return CCBreaker.db.char.showfrom.raidpet end,
							set = function(v) CCBreaker.db.char.showfrom.raidpet = v end,
						},
						others = {
							type = "toggle",
							name = CCLocale["others"],
							desc = CCLocale["Show break from others"],
							get = function() return CCBreaker.db.char.showfrom.others end,
							set = function(v) CCBreaker.db.char.showfrom.others = v end,
						},  
					}, 
				},
				showeffects = {
					type = "group",
					name = CCLocale["show effects"],
					desc = CCLocale["Report CC breaks of effects"],
					args = {
						freezingtrap = {
							type = "toggle",
							name = CCBabble["Freezing Trap"],
							desc = string.gsub(CCLocale["Show break of [spell]"],"[spell]",CCBabble["Freezing Trap"]),
							get = function() return CCBreaker.db.char.showeffects.freezingtrap end,
							set = function(v) CCBreaker.db.char.showeffects.freezingtrap = v end,
						},
						hibernate = {
							type = "toggle",
							name = CCBabble["Hibernate"],
							desc = string.gsub(CCLocale["Show break of [spell]"],"[spell]",CCBabble["Hibernate"]),
							get = function() return CCBreaker.db.char.showeffects.hibernate end,
							set = function(v) CCBreaker.db.char.showeffects.hibernate = v end,
						},
						polymorph = {
							type = "toggle",
							name = CCBabble["Polymorph"],
							desc = string.gsub(CCLocale["Show break of [spell]"],"[spell]",CCBabble["Polymorph"]..", "
								..CCBabble["Polymorph: Pig"].." and "
								..CCBabble["Polymorph: Turtle"]),
							get = function() return CCBreaker.db.char.showeffects.polymorph end,
							set = function(v) CCBreaker.db.char.showeffects.polymorph = v end,
						},
						sap = {
							type = "toggle",
							name = CCBabble["Sap"],
							desc = string.gsub(CCLocale["Show break of [spell]"],"[spell]",CCBabble["Sap"]),
							get = function() return CCBreaker.db.char.showeffects.sap end,
							set = function(v) CCBreaker.db.char.showeffects.sap = v end,
						},
						shackleundead = {
							type = "toggle",
							name = CCBabble["Shackle Undead"],
							desc = string.gsub(CCLocale["Show break of [spell]"],"[spell]",CCBabble["Shackle Undead"]),
							get = function() return CCBreaker.db.char.showeffects.shackleundead end,
							set = function(v) CCBreaker.db.char.showeffects.shackleundead = v end,
						},
					}, 
				},
			},
		},
	},
}

function CCBreaker:reset()
	self.lastinfo = nil
	self:recyclebreakertable()
	self:UpdateText()
end

CCBreaker:RegisterChatCommand(CCLocale["Slash-Commands"],CCBreaker.OnMenuRequest)




